/*************************************************************
	GA-1024A / GA-1280A OtBbNCu Tv\[X

		SAMPLE.C
			
				ACEI[Ef[^@@Device Inc...
**************************************************************/
#include "gagraph.h"
#include <math.h>

#ifndef TURBO
#include <malloc.h>
#else
#include <alloc.h>
#endif

#define	XO	256
#define	YO	128

extern void far VWait(int);    /* ԑ҂ */
extern int	far GetMouse(int far *,int far *,int far *,int far *);
extern int	far InitMouse();

void ball();
void moveball();
void line_box();
void zukei();
void gradation();
void save_restore();
void gacursor();
void painttest();
/****************************
	}EXJ[\̃f[^
****************************/
static char andmask[] = {
	0xff,0x80,0xff,0xff,
	0xfe,0x00,0x3f,0xff,
	0xfc,0x00,0x1f,0xff,
	0xf8,0x00,0x0f,0xff,
	0xf0,0x00,0x0f,0xff,
	0xf0,0x00,0x07,0xff,
	0xe0,0x00,0x07,0xff,
	0xe0,0x00,0x07,0xff,
	0xe0,0x00,0x07,0xff,
	0xe0,0x00,0x07,0xff,
	0xe0,0x00,0x03,0xff,
	0xe0,0x00,0x03,0xff,
	0xf0,0x00,0x03,0xff,
	0xf0,0x00,0x03,0xff,
	0xf8,0x00,0x07,0xff,
	0xf8,0x00,0x07,0xff,
	0xf8,0x00,0x03,0xff,
	0xf0,0x00,0x01,0xff,
	0xe0,0x00,0x01,0xff,
	0xe0,0x00,0x00,0xff,
	0xe0,0x00,0x07,0xff,
	0xe0,0x00,0x07,0xff,
	0xe3,0x00,0x07,0xff,
	0xf7,0x00,0x07,0xff,
	0xff,0x80,0x07,0xff,
	0xff,0xc0,0x07,0xff,
	0xff,0xe0,0x07,0xff,
	0xff,0xf0,0x00,0x7f,
	0xff,0xfc,0x00,0x3f,
	0xff,0xff,0x80,0x7f,
	0xff,0xff,0xc7,0xff,
	0xff,0xff,0xe7,0xff,
};


static char xormask[] = {
	0x00,0x00,0x00,0x00,
	0x00,0x7f,0x00,0x00,
	0x01,0xff,0xc0,0x00,
	0x03,0xff,0xe0,0x00,
	0x07,0xff,0x60,0x00,
	0x07,0xef,0x90,0x00,
	0x0f,0x9f,0xf0,0x00,
	0x0f,0xff,0x10,0x00,
	0x0f,0x8f,0x50,0x00,
	0x0f,0xaf,0x18,0x00,
	0x0f,0x8f,0xf8,0x00,
	0x0f,0xff,0x78,0x00,
	0x07,0xfe,0x18,0x00,
	0x07,0xf8,0xf8,0x00,
	0x03,0xff,0xf0,0x00,
	0x03,0x9f,0xc0,0x00,
	0x03,0xe0,0x38,0x00,
	0x07,0xff,0xfc,0x00,
	0x0f,0xff,0xec,0x00,
	0x0f,0xff,0xf6,0x00,
	0x0f,0xff,0xf0,0x00,
	0x0e,0xff,0xf0,0x00,
	0x08,0x7f,0xf0,0x00,
	0x00,0x7f,0xf0,0x00,
	0x00,0x3f,0xf0,0x00,
	0x00,0x1f,0xf0,0x00,
	0x00,0x0f,0xf0,0x00,
	0x00,0x07,0xf8,0x00,
	0x00,0x00,0xff,0x80,
	0x00,0x00,0x38,0x00,
	0x00,0x00,0x10,0x00,
	0x00,0x00,0x00,0x00,
};



/********************************
	^Cp^[̃f[^
*********************************/
static char tile[]={
		0x00, 0x00, 0x66, 0x00, 0x00, 0x42, 0x3c, 0x00, 
		0x00, 0x00, 0x66, 0x00, 0x00, 0x42, 0x3c, 0x00, 
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
		0x00, 0x00, 0x66, 0x00, 0x00, 0x42, 0x3c, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
};
/*********************************
	main()
**********************************/
void main()
{
	if ( GAinit( HRESO_256C ) ) {  /* 1024x768   256Color */
		printf("\nGAINIT.EXE풓Ă܂\n");
		exit(1);
	}
	GAclrScreen();
	GAcrtSel(CRT_GA);    /* CRT GA-1024Aɐ؊ */
	VWait(50);

	line_box(200,200,824,568,-1);
	zukei();
	painttest();
	scroll();
	moveball();		/*  ̊֐̓J[pbgύX  */
	save_restore();
	gradation();	/*  ̊֐̓J[pbgύX  */
	gacursor();

	GAcrtSel(CRT_PC);    /* CRT {̂ɐ؊ */
	GAterm( PAL_DEF );		/*	I֐	*/
	exit(0);
}


/**********************************************************
	̋`@
***********************************************************/
void ball( x, y, r)
int		x;
int		y;
int		r;		/*  1 - 256  */
{
	int		i, j, c;
	double  z,rr,zz,xx;

	z = 255.0 / r;
	rr = (double)r * (double)r;
	for (i = 0; i < r; i++) {
		xx = r - i;
		zz = sqrt( rr - xx * xx ) ;
		c = zz * z;
		GAcircleFill(x, y, r-i, c);
	}
}



/*******************************************************
	GAcopyImage Ń{[œ
********************************************************/
void moveball()
{
	int		x, y, c;
	int		i, j;
	struct	PALETTE pal;


	x = 0;
	y = 384;


	for (i = 0; i < 256; i++){
		c = i >> 4;
		pal.red   = c*c;
		pal.green = i;
		pal.blue  = i;
		GAsetPalette((void far *)&pal, i);
	}
	GAclrScreen();
	GAputStr( 450,0,"Rs|",255,TRANSPARENT,BOLD);
	ball(x+32,y+32,32);
	for(j = 0; j < 1; j++){
		for(i = 0; i < 1023-63-16; i+=16){
			GAcopyImage(x, y, x+63+16, y+63, i, y);
			x = i;
		}
		for(i = 1023-63-16; i > 0 ; i-=16){
			GAcopyImage(x, y, x+63+16, y+63, i, y);
			x = i;
		}
	}
	for(j = 0; j < 2; j++){
		for(i = 0; i < 1023-63-16; i+=16){
			GAcopyImage(x, y, x+63+16, y+63, i, y);
			x = i;
		}
		for(i = 1023-63-16; i > 0 ; i-=16){
			GAcopyImage(x, y, x+63+16, y+63, i, y);
			x = i;
		}
	}
	x = 512;
	y = 0;
	ball(x+32,y+32,32);
	for(j = 0; j < 3; j++){
		for(i = 0; i < 766-64-16; i+=16){
			GAcopyImage(x, y, x+63, y+63+16, x, i);
			y = i;
		}
		for(i = 766-64-16; i > 0 ; i-=16){
			GAcopyImage(x, y, x+63, y+63+16, x, i);
			y = i;
		}
	}
	VWait(100);
}



/******************************************************
	ׂĂ̕ɃC`
*******************************************************/
void line_box(x0,y0,x1,y1, style)
int		x0,y0,x1,y1;
short	style;
{
	int		i;
	int		x,y;

	x = (x1 - x0) / 2 + x0;
	y = (y1 - y0) / 2 + y0;

	GAputStr( 450,0,"C`",7,TRANSPARENT,BOLD );
	for(i = x0; i <= x1; i++){
		GAline(x, y, i, y0, 1, style);
	}
	for(i = y0; i <= y1; i++){
		GAline(x, y, x1, i, 2, style);
	}
	for(i = x1; i >= x0; i--){
		GAline(x, y, i, y1, 3, style);
	}
	for(i = y1; i >= y0; i--){
		GAline(x, y, x0, i, 4, style);
	}
	VWait(100);
}



/***********************************************************
	~AOpAlp 
************************************************************/
void zukei()
{
	int		i;
	int		sx,sy;
	long	size;

	GAclrScreen();
	GAputStr( 450,0,"~AOpAlp",7,TRANSPARENT,BOLD );

	GAsetTile((void far *)tile);

	GAcircle(256,172,100, 1, 0xfccc);
	GAcircleFill(256,384,100, 2);
	GAtiledCircle(256,596,100);

	GAtriangle(512,72,412,272,612,272, 3, 0x5555);
	GAtriangleFill(512,284,412,484,612,484, 4);
	GAtiledTriangle(512,496,412,696,612,696);

	GAbox(668,72,868,272, 5, 0x0f0f);
	GAboxFill(668,284,868,484, 6);
	GAtiledBox(668,496,868,696);
	VWait(100);
}


/***************************************************
	pbgς 256FOf[V\
****************************************************/
void gradation()
{

	struct	PALETTE pal;

	int i;
	int r,g,b,hol,ver;

	hol = 1024/16;
	ver = 768/16;
	GAclrScreen();

	GAsetVisualPlane(-1);
	for (i=0;i<256;i++) {
			GAboxFill( (i&15)*hol,(i/16)*ver,(i&15)*hol+(hol-2),(i/16)*ver+(ver-2),i);
	}
	GAputStr( 450,0,"Of|V",255,TRANSPARENT,BOLD );
	for (i=0;i<256;i++) {
		r = (15 - (i&15) - (i/16))*16 ;
		if (r < 0) r = -r;
		g = (i / 16) * 16;
		b = (i & 15) * 16;
		pal.red   = r;
		pal.green = g;
		pal.blue  = b;
		GAsetPalette((void far *)&pal, i);
	}
	GAsetVisualPlane(0);
	VWait(100);


	GAsetVisualPlane(-1);
	for (i=0;i<256;i++) {
		r = ((i&15) + (i/16)- 15)*16 ;
		if (r < 0) r = 0;
		b = ((i&15) - (i/16))*16 ;
		if (b < 0) b = 0;
		g = ((i/16)-(i&15))*16 ;
		if (g < 0) g = 0;
		pal.red   = r;
		pal.green = g;
		pal.blue  = b;
		GAsetPalette((void far *)&pal, i);
	}
	GAsetVisualPlane(0);
	VWait(100);
}

/************************************************************
	 XN[
*************************************************************/
static char moji[]={ " f`|POQS`@ijACEI[Ef[^@@Device Inc...  "};

scroll()
{
	int		dy;
	int		x,y;

	GAinit(1);
	GAclrScreen();
	GAputStr( 450,0," XN[",7,TRANSPARENT,BOLD );

	GAbox(XO-1,YO-1,XO+504,YO+514,7,-1);
	GAsetClipRgn(XO,YO,XO+503,YO+511);

	dy = 2;
	for(y = 140; y; y-=dy){ 
		GAcopyImage(XO, YO+dy, XO+511, YO+513, XO, YO);
		GAputStr( XO, YO+y%20+495, moji, 7-(y/20), y > 60 ? 7-(y/20)+1 : -1 , (y/20)%4);
	}
	for(y = 560; y; y-=dy){
		GAcopyImage(XO, YO+dy, XO+511, YO+513, XO, YO);
	}
	GAsetClipRgn(-1,0,0,0);
}



/***************************************************************
	Z[uAXgA
*****************************************************************/
void save_restore()
{
	int		x,y;
	int		mode;
	long	size;
#ifndef TURBO
	void huge	*savep;
#else
	void far	*savep;
#endif


/*	Z[u XgA 	[hO  */
	GAclrScreen();
	GAputStr( 400,0,"Z[u XgA [hO (-)",255,TRANSPARENT,BOLD);

	ball(32,32,32);
	size = GAsaveImage(0,0,63,63,PLANE_MODE,0L);
#ifndef TURBO
	savep = halloc(size,1);
#else
	savep = farmalloc(size);
#endif
	GAsaveImage(0,0,63,63,PLANE_MODE,savep);
	GAsetClipRgn(80,83,1001,602);
	for(y = 0; y < 768; y+=64){
		for(x = 0; x < 1024; x+=64){
			GArestoreImage(x,y,x+63,y+63,PLANE_MODE,savep);
		}
	}
#ifndef TURBO
	hfree(savep);
#else
	farfree(savep);
#endif
	VWait(100);
	GAsetClipRgn(-1,0,0,0);


/*	Z[u XgA 	[hP  */
	GAclrScreen();
	GAputStr( 400,0,"Z[u XgA [hP (߸)",255,TRANSPARENT,BOLD);

	ball(32,32,32);
	size = GAsaveImage(0,0,63,63,PIXEL_MODE,0L);
#ifndef TURBO
	savep = halloc(size,1);
#else
	savep = farmalloc(size);
#endif
	GAsaveImage(0,0,63,63,PIXEL_MODE,savep);
	GAsetClipRgn(80,83,1001,602);
	for(y = 0; y < 768; y+=64){
		for(x = 0; x < 1024; x+=64){
			GArestoreImage(x,y,x+63,y+63,PIXEL_MODE,savep);
		}
	}
#ifndef TURBO
	hfree(savep);
#else
	farfree(savep);
#endif
	VWait(100);
	GAsetClipRgn(-1,0,0,0);


/*	Z[u XgA 	[hQ  */
	GAclrScreen();
	GAputStr( 400,0,"Z[u XgA [hQ (߯ ߯)",255,TRANSPARENT,BOLD);

	ball(32,32,32);
	GAsetClipRgn(80,83,1001,602);
	for(y = 0; y < 768; y+=64){
		for(x = 0; x < 1024; x+=64){
			GAsaveImage(0,0,63,63,PUSH_POP,0L);
			GArestoreImage(x,y,x+63,y+63,PUSH_POP,0L);
		}
	}
	VWait(100);
	GAsetClipRgn(-1,0,0,0);




/*	Z[u XgA    [hW  */
	GAclrScreen();
	GAputStr( 400,0,"Z[u XgA [hW (޲ ײ)",255,TRANSPARENT,BOLD);
	ball(32,32,32);
	size = GAsaveImage(0,0,63,63,BYTE_ALIGN,0L);
#ifndef TURBO
	savep = halloc(size,1);
#else
	savep = farmalloc(size);
#endif
	GAsaveImage(0,0,63,63,BYTE_ALIGN,savep);
	GAsetClipRgn(80,83,1001,602);
	for(y = 0; y < 768; y+=64){
		for(x = 0; x < 1024; x+=64){
			GArestoreImage(x,y,x+63,y+63,BYTE_ALIGN,savep);
		}
	}
#ifndef TURBO
	hfree(savep);
#else
	farfree(savep);
#endif
	GAsetClipRgn(-1,0,0,0);
	VWait(100);
}

/******************************************************
	J[\\
********************************************************/
void gacursor()
{
	int 	i,x,y;
	struct	PALETTE pal;
	int     wx=0,wy=0,left,right=0;

	pal.red   = 255;
	pal.green = 255;
	pal.blue  = 255;
	GAsetPalette((void far *)&pal, 255);

	GAclipControl( 0,0,0,0,0,0);
	GAputStr( 440,0,"J [ \  \ ",255, 0,BOLD);
	GAsetCursor((char far *)andmask,(char far *)xormask);
	if (InitMouse()){ /* MOUSE.SYSo^ĂȂꍇ */
		for(i = 0; i < 500; i+=8) {
			GAdrawCursor(i,i);
			VWait(5);
		}
		VWait(50);
	} else { /* MOUSE.SYSgp */
		GAputStr( 440,30,"ENbNŏI܂",255, 0, 0);
		while(!right){
			GetMouse(&x, &y, &left, &right);
			if (wx != x || wy != y){
				GAdrawCursor(x,y);
			}
			wx = x;
			wy = y;
		}
	}
	GAeraseCursor();
}

/**************************************************
  yCg
****************************************************/
void painttest()
{
	int		i;
	int		sx,sy;
	long	size;

	GAclrScreen();
	GAputStr( 450,0,"yCg",7,TRANSPARENT,BOLD);
	GAsetTile((void far *)tile);

	GAcircle(256,272,200, 3, 0xffff);
	GAtriangle(512,72,412,272,612,272, 3, 0xffff);
	GAbox(368,572,868,760, 5, 0xffff);
	VWait(20);
	GApaint(256,272,3,6);
	GAtiledPaint(512,172,3);
	GApaint(700,600,5,1);
	VWait(100);


}


#if 0
/********************************************************************

	OtBbNɒڕ`悷ꍇ͂̃\|XQlɂĉ
	
      TURBO C ̏ꍇ outp() outportb()ɁAoutpw() outportw()
      ύXĂ
*********************************************************************/

/* ̨ - ڼ޽ - */
#define SRW_    0x0100
#define SRR_    0x0200
#define WPM     0x0300
#define WBM_    0x0500
#define RPS     0x0600
#define RPE     0x0700
#define COL     0x0900
#define TILE_   0x0b00
#define MOD1    0x0e00
#define MOD2    0x0e01
#define CRTC_AR 0x1e00
#define CRTC_CR 0x1f00

direct()
{
	unsigned int  gaport;
	volatile char far *ga_wind; /* ̨RAM̃|C^ volatilet */

	struct VDCONFIG vd;
	int    x,y;
	int    wpm_save;
	char   a,b;

	GAgetVideoConfig((void far *)&vd);
	gaport = vd.port	;                           /* GA WX^̃|[gԍ */
	ga_wind = (void far *) ((long)vd.ga_seg	<< 16); /*OtBbN{[hEBhẼZOg*/

	x = 100;
	y = 512;
	a = 0xfc;
	wpm_save = inp(WPM+gaport);  /* ײ - Ͻ ۑ   */
	outp(MOD1+gaport,0);         /* ̨ -ׂ- */
	outpw(WBM_+gaport,0x3f3f);   /* ײ ޯϽ           */
	outpw(SRW_+gaport,y );       /* ײ -׽ (Y)      */
	outp(WPM+gaport,7);          /* ײ - Ͻ        */
	*(ga_wind + (x >> 3)) = a;   /* ̨؂ײı   */

	outpw(SRR_+gaport,y);        /* - -׽ */
	outp(RPS+gaport,2);          /* - -   */
	b = *(ga_wind + (x >> 3));   /* ̨؂-ޱ   */

/* MOD1 WBM WPM ̫Ăɂǂ */
	outp(MOD1+gaport,1);          /* ̨ - - 1 */
	outpw(WBM_+gaport,0xffff) ;   /* ײ ޯϽ           */
	outp(WPM+gaport,wpm_save);    /* ײ - Ͻ         */
}

/*****************************************
	sNZ ZbgōsȂꍇ
*****************************************/
void setPixel(x1,y1,color)     
int x1,y1,color;
{
 static unsigned char smask[8] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

	int j,bx;
	volatile uchar far *p;

	outp(gaport+MOD1,1) ;
	outpw(gaport+SRW_,y1);
	outp(gaport+WPM,-1);
	outp(gaport+COL,color);
	j =  x1 & 7 ;
	bx = x1 >> 3;
	p = ga_wind + bx ;
	*p = smask[j];
}


#endif

#if 0
/****************************************************************************

	}EXJ|\荞݂ŏꍇ͈ȉ̃\|XQlɂĂ

  MS-DOSYtMOUSE.SYSgݍ܂Ă邱ƂKvł

  CallMouse() Ăяo΃}EXJ|\荞݂ŏ܂
  ReleaseMouse()Ŋ荞݂

*****************************************************************************/

/*}EXړƂ̊֐Ă΂*/
void far intMouse()
{
	struct	HWREG hw;
	int	x,y,left,right;

	GAsaveHwRegister(&hw);
	GetMouse(&x,&y,&left,&right);
	if (disp_flag) GAdrawCursor(x,y);
	GArestoreHwRegister(&hw);
}


/*  AZuLq */

;  荞݂̐ݒ
_CallMouse	proc	far
		mov 	ax,cs
		mov 	es,ax
		mov 	dx,offset mouse_move  ;̊֐
		mov 	ax,0ch		; 
		mov 	cx,1	    ; R[
		int 	33h
		ret
_CallMouse	endp

mouse_move		proc	far
		push	ds
		mov 	ax,DGROUP
		mov 	ds,ax
		call	far ptr _intMouse   ; ̊֐
		pop 	ds
		ret
mouse_move		endp

_ReleaseMouse	proc	far
		mov 	cx,0	;  R[
		mov 	ax,0ch
		int 	33h
		ret
_ReleaseMouse	endp

#endif

